#include <iostream>
#include <SDL/SDL.h>

int main ( int argc, char** argv )
{
    /// [1] Démarrage
    // [1.1] Démarrages SDL
    if ( SDL_Init( SDL_INIT_VIDEO ) < 0)
    {
        std::cout << "Impossible d'initialiser la SDL: " << SDL_GetError() << std::endl;
        return 1;
    }

    // [1.2] Préparation de fermeture
    atexit(SDL_Quit);

    // [1.3] Para-fenêtre
    SDL_WM_SetCaption("Color", 0);

    /// [2] Préparation des composants
    // [2.1] Préparation de la fenêtre
    SDL_Surface* screen = SDL_SetVideoMode(160, 90, 32,
                                           SDL_HWSURFACE|SDL_DOUBLEBUF);
    if ( !screen )
    {
        std::cout << "Unable to set 640x480 video: " << SDL_GetError() << std::endl;
        return 1;
    }

    // [2.2] Préparation
    Uint32 couleur(0);
    Uint16 red;
    Uint16 green;
    Uint16 blue;

    /// [3] Boucle principale
    bool done = false;
    while (!done)
    {
        // [3.1] Gestion évènements
        SDL_Event event;
        while (SDL_PollEvent(&event))
        {
            switch (event.type)
            {
            case SDL_QUIT:
                done = true;
                break;
            case SDL_KEYDOWN:
                if (event.key.keysym.sym == SDLK_ESCAPE)
                    done = true;
                break;
            } // end switch event type
        } // end of message processing

        // [3.2] Demande de couleur
        std::cout << "Entrez la quantité, de 0 à 255 (300 pour quitter), de" << std::endl;
        std::cout << "red ";
        std::cin >> red;
        if (red>255)
            break;
        std::cout << "green ";
        std::cin >> green;
        std::cout << "blue ";
        std::cin >> blue;

        // [3.3] Dessin des composants
        couleur = SDL_MapRGB(screen->format,red,green,blue);
        std::cout << "32 bits code: " << couleur << std::endl;
        SDL_FillRect(screen, 0, couleur);

        SDL_Flip(screen);
    } //fin bcl principale

    ///[4] Destruction des composants
    SDL_FreeSurface(screen);


    std::cout << "Aucune erreur détectée." << std::endl;
    return 0;
}
